#!/bin/perl

package PrintData;
use strict;
use warnings;
my $debug = -4;

sub new {
    
    my ($class) = shift;
    #my ($symbolID) = shift;


    my $self =  {
                  _indents            => [],             # array of indent
                  _bars               => [],             # array of '|' flags
                 # _previouslyCalled   => {$symbolID,1},   # hash for previously called functions
                  _previouslyCalled   => {0,1},   # hash for previously called functions
                };

    bless $self,$class;
    return $self;
}


sub get_previouslyCalled   { 
    my @prevCalled = keys (%{$_[0]->{_previouslyCalled}});
    print("getting previously called \n") if $debug > 0;
    foreach my $called (@prevCalled) {
        print("\"",$called,"\"\n") if $debug > 0;
    }
    return @prevCalled;
}


sub set_previouslyCalled { 
    unless ($_[0]->{_previouslyCalled}{$_[1]}) {
        print("adding to previously called \"",$_[1],"\"\n") if $debug > 2;
        $_[0]->{_previouslyCalled}{$_[1]} = 1; 
    }
} 

sub removeFunctionFromPreviouslyCalled { 
    if(exists($_[0]->{_previouslyCalled}{$_[1]})) { 
        delete($_[0]->{_previouslyCalled}{$_[1]}); 
    }
} 

    
# Indent and Bars
# No access to indents or bars separately, except last bar
sub addToIndentsAndBars { 
    push(@{$_[0]->{_indents}},$_[1]); 
    push(@{$_[0]->{_bars}},$_[2]); 
} 

sub removeLastIndentAndBar { 
    pop(@{$_[0]->{_indents}});     
    pop(@{$_[0]->{_bars}});

} 

sub getIndentsAndBars {
    my $indent = "";
    my $spacing;
    print("pulling indent array\n") if $debug > 2;
    my @indentsArray = @{$_[0]->{_indents}};
    my @barsArray = @{$_[0]->{_bars}};
    print("\@indentsArray =\"@indentsArray\"\n") if $debug > 2;
    for(my $i=0; $i<@indentsArray; $i++) {
        $spacing = " " x $indentsArray[$i];
        $indent .= $spacing;
        $indent .= $barsArray[$i] ? "|" : " ";
    }
    return $indent;
}

sub changeLastBarToSpace {
    my @barsArray = @{$_[0]->{_bars}};
    my $totalBarElements = scalar(@barsArray);
    ${$_[0]->{_bars}}[$totalBarElements - 1] = 0 if $totalBarElements;
}



                       
return 1;
